#include <ctype.h>
#include <libgen.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <sys/xattr.h>
#include "parse.h"
#include "print.h"
#include "xattr.h"

#ifndef ARRAY_SIZE
# define ARRAY_SIZE(x) (sizeof(x)/sizeof(x[0]))
#endif

int main(int argc, char* argv[])
{
    if (argc < 2) {
        fprintf(stderr, "Usage: %s path...\n", basename(argv[0]));
        return 1;
    }

    int ret = 0;
    for (int i = 1; i < argc; ++i) {
        if (argc > 2) {
            printf("%s: ", argv[i]);
        }

        char buf[4096];
        ssize_t len = getxattr(argv[i], "user.DOSATTRIB", buf, ARRAY_SIZE(buf));
        if (len == -1) {
            fprintf(stderr, "Missing or invalid user.DOSATTRIB attribute\n");
            ret = 1;
        }

        struct xattr_DOSATTRIB dosattrib;
        if (parse_dosattrib(&dosattrib, buf, len)) {
            fprintf(stderr, "Could not parse user.DOSATTRIB attribute\n");
            ret = 1;
        }

        print_dosattrib(&dosattrib);
        printf("\n");
    }
    return ret;
}

