#include <string.h>
#include <time.h>
#include "nttime.h"

#define NS_PER_INTERVAL 100
#define TICKS_PER_SECOND 10000000
#define EPOCH_DIFFERENCE 11644473600LL

static time_t nttime_to_unix_time(NTTIME nttime)
{
    long long int temp;
    temp = nttime / TICKS_PER_SECOND; //convert from 100ns intervals to seconds;
    temp = temp - EPOCH_DIFFERENCE;  //subtract number of seconds between epochs
    return (time_t) temp;
}

int nttime_parse(struct parsed_time* p, NTTIME nttime)
{
    memset(p, 0, sizeof(struct parsed_time));

    time_t t = nttime_to_unix_time(nttime);

    struct tm tm;
    gmtime_r(&t, &tm);

    p->year = tm.tm_year + 1900;
    p->month = tm.tm_mon + 1;
    p->day = tm.tm_mday;
    p->hour = tm.tm_hour;
    p->min = tm.tm_min;
    p->sec = tm.tm_sec;
    p->nsec = (nttime % TICKS_PER_SECOND) * NS_PER_INTERVAL;
    return 0;
}