#include <string.h>
#include "parse.h"

int parse_dosattrib(struct xattr_DOSATTRIB* dosattrib, char* buf, ssize_t len)
{
    // First four bytes are NDR flags
    uint32_t flags;
    memcpy(&flags, buf, 4);
    // Next two bytes are version
    uint16_t version;
    memcpy(&version, buf + 4, 2);
    // Next two bytes relate to ndr_pull_set_switch_value or padding, we ignore this
    // Next bytes are the struct values itself
    switch (version) {
    case 4:
        dosattrib->attrib_hex = NULL;
        dosattrib->version = 4;
        memcpy(&dosattrib->info.info4.valid_flags, buf + 8, 4);
        memcpy(&dosattrib->info.info4.attrib, buf + 12, 4);
        memcpy(&dosattrib->info.info4.itime, buf + 16, 8);
        memcpy(&dosattrib->info.info4.create_time, buf + 24, 8);
        break;
    default:
        return 1;
    }

    return 0;
}
