#pragma once

#include <stdint.h>

// These definitions are copied from Samba-4.11.1 xattr.h and friends

/* 64 bit time (100 nanosec) 1601 - cifs6.txt, section 3.5, page 30, 4 byte aligned */
typedef uint64_t NTTIME;

struct xattr_DosInfoFFFFCompat {
	uint32_t attrib;
};

struct xattr_DosInfo1 {
	uint32_t attrib;
	uint32_t ea_size;
	uint64_t size;
	uint64_t alloc_size;
	NTTIME create_time;
	NTTIME change_time;
};

struct xattr_DosInfo2Old {
	uint32_t flags;
	uint32_t attrib;
	uint32_t ea_size;
	uint64_t size;
	uint64_t alloc_size;
	NTTIME create_time;
	NTTIME change_time;
	NTTIME write_time;
	const char * name;/* [flag(LIBNDR_FLAG_STR_UTF8|LIBNDR_FLAG_STR_NULLTERM)] */
};

/* bitmap xattr_DosInfoValidFlags */
#define XATTR_DOSINFO_ATTRIB ( 0x00000001 )
#define XATTR_DOSINFO_EA_SIZE ( 0x00000002 )
#define XATTR_DOSINFO_SIZE ( 0x00000004 )
#define XATTR_DOSINFO_ALLOC_SIZE ( 0x00000008 )
#define XATTR_DOSINFO_CREATE_TIME ( 0x00000010 )
#define XATTR_DOSINFO_CHANGE_TIME ( 0x00000020 )
#define XATTR_DOSINFO_ITIME ( 0x00000040 )

/* FileAttributes (search attributes) field */
#define FILE_ATTRIBUTE_READONLY		0x0001L
#define FILE_ATTRIBUTE_HIDDEN		0x0002L
#define FILE_ATTRIBUTE_SYSTEM		0x0004L
#define FILE_ATTRIBUTE_VOLUME		0x0008L
#define FILE_ATTRIBUTE_DIRECTORY	0x0010L
#define FILE_ATTRIBUTE_ARCHIVE		0x0020L
#define FILE_ATTRIBUTE_DEVICE		0x0040L
#define FILE_ATTRIBUTE_NORMAL		0x0080L
#define FILE_ATTRIBUTE_TEMPORARY	0x0100L
#define FILE_ATTRIBUTE_SPARSE		0x0200L
#define FILE_ATTRIBUTE_REPARSE_POINT	0x0400L
#define FILE_ATTRIBUTE_COMPRESSED	0x0800L
#define FILE_ATTRIBUTE_OFFLINE		0x1000L
#define FILE_ATTRIBUTE_NONINDEXED	0x2000L
#define FILE_ATTRIBUTE_ENCRYPTED	0x4000L

struct xattr_DosInfo3 {
	uint32_t valid_flags;
	uint32_t attrib;
	uint32_t ea_size;
	uint64_t size;
	uint64_t alloc_size;
	NTTIME create_time;
	NTTIME change_time;
};

struct xattr_DosInfo4 {
	uint32_t valid_flags;
	uint32_t attrib;
	NTTIME itime;
	NTTIME create_time;
};

union xattr_DosInfo {
	struct xattr_DosInfoFFFFCompat compatinfoFFFF;/* [case(0xFFFF)] */
	struct xattr_DosInfo1 info1;/* [case] */
	struct xattr_DosInfo2Old oldinfo2;/* [case(2)] */
	struct xattr_DosInfo3 info3;/* [case(3)] */
	struct xattr_DosInfo4 info4;/* [case(4)] */
}/* [public,switch_type(uint16)] */;

struct xattr_DOSATTRIB {
	const char * attrib_hex;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM)] */
	uint16_t version;
	union xattr_DosInfo info;/* [switch_is(version)] */
}/* [noprint,nopull,nopush,public] */;

