#!/bin/bash

set -euo pipefail

GETDOSATTRIB=./tools/getdosattrib/getdosattrib
if [[ ! -x $GETDOSATTRIB ]]; then
  echo "ERROR: $GETDOSATTRIB is not executable" 1>&2
  exit 1
fi

touch test.txt

# A v4 Samba DOSATTRIB
setfattr -n user.DOSATTRIB -v 0sAAAEAAQAAABRAAAAIAAAAB7ASJHB4NcBHsBIkcHg1wE= test.txt
EXPECTED='{"attrib":"ARCHIVE","createTime":"2021-11-23T23:26:40.1493022Z","instantiationTime":"2021-11-23T23:26:40.1493022Z"}'
ACTUAL=$($GETDOSATTRIB test.txt)
if [[ "$EXPECTED" != "$ACTUAL" ]]; then
  echo "ERROR: Expected \"$EXPECTED\", actual \"$ACTUAL\"" 1>&2
  exit 1
fi
